//=============================================================================
// 쌠 ATMEL Corporation 2003. S\ς
//
// ̧:		AES.h
// ߲:		WC++߲
// o͗:
// Ǝ:	OE, VU
// 쐬:		4-Feb-2003	JP (ATMEL̨)
// ύX:		21-Feb-2005 (AESp)    RAA (ATMELٳ)
//
// xҰ:		avr@atmel.com
//
// :		葽̏ɂĂ͉pLqQƂĂB
//
//=============================================================================

#ifndef AES_H
#define AES_H

#include "DataBuffer.h"

class Aes
{
public:
	Aes(DataBuffer& initialVector, int keyCount);
	~Aes() {};

	void scheduleKey(DataBuffer key[3]);
	DataBuffer getK(int key, int index) const;
	void encrypt(unsigned char *buffer, unsigned char *chainBlock) const;
	void encryptBuffer(DataBuffer& buffer);

private:
	unsigned char chainBlockM[16];
	unsigned char keyTableM[16+8+8];
	int keyCountM;

	void removeParityBits( const unsigned char * withparity, 
			       unsigned char * withoutparity ) const;
	unsigned char getbit( const unsigned char * bits, unsigned int pos ) const;
	void setbit( unsigned char * bits, unsigned int pos, unsigned char value ) const;
	void checkParity( const unsigned char * bits ) const;
};

#endif // AES_H
