//=============================================================================
// 쌠 (C) 2003 ATMEL Corporation
//
// ̧:		Update.cpp
// ߲:		WC++߲(Win32)
// o͗:
// Ǝ:	E, VU
// 쐬:		27-Feb-2003	JP (ATMEL̨)
// ύX:		21-Mar-2005 (AESpɕύX)    RAA (ATMELٳ)
//
// xҰ:		avr@atmel.com
//
// :		۸т͖ړIΏAVRɈÍ̧ق𑗂̂Ɏgp
//				BÍ̧ق'create'°قpč쐬܂B
//
// ̑:
//=============================================================================

#include "ComPort.h"
#include "update.h"
#include <stdio.h>
#include <ctype.h>

//=============================================================================

char *progressChars =
	"--\\\\||//";

//=============================================================================

char *copyrightString =
	"update v1.0 - Copyright (C) 2003 Atmel Corporation\n\n";

//=============================================================================

const char *usageString =
	"usage: update <filename.ext> [-COMx] [-baudrate]\n\n"
	"  filename.ext    File containing flash upgrade buffer.\n"
	"  -COMx           Communications port number.\n"
	"  -baudrate       Communication baudrate, e.g. 9600, 115200.\n"
	"                  Supported baudrates:\n"
	"                    110, 300, 600, 1200, 2400,\n"
	"                    4800, 9600, 14400, 19200, 38400,\n"
	"                    56000, 57600, 115200, 128000, 256000\n\n";

//=============================================================================
// n܂܂!BCOM߰ĂvJAɏՕ̧قǂ݁ACOM߰ČoRŖ
// IΏ޲֊ɏՕ𑗂܂B

int main(int argc, char* argv[])
{
	FILE *inFile;

	char comPortName[5];			// ]ɎgpCOM߰Ė
	unsigned char receivedByte;		// COM߰ĂM1޲
	unsigned char retries = 0;		// ܂ł̎s
	int index;						// ްɏՕ̎wW
	int frameSize;					// ݂ڰѓ޲Đ
	int bufferSize = 0;				// ɏՕ̑޲Đ
	int bytesSent = 0;				// ܂łɑ޲Đ

	unsigned char buffer[0x40000];	// ްopްɏՕ

	printf(copyrightString);

	ComPort *comPort = new ComPort;	// COM߰ ޼ުĂ̲ݽݽ

	argc--;
	argv++;

	// SȂꍇɌүނo
	if ((argc != 3) || (argv[0][0] == '-'))
	{
		printf(usageString);
		return -1;
	}

	// COM߰Ĕԍǂݍ
	for( char * cp = argv[1]; *cp; cp++ ) {
		*cp = toupper( *cp );
	}
	if(strstr(argv[1], "-COM"))
		strcpy(comPortName, &argv[1][1]);
	else
	{
		printf(usageString);
		return -1;
	}

	// ްڰēǂݍ(菬Ȃ̂:-DłSɎx܂B)
	long baudrate;
	if( strcmp( argv[ 2 ], "-256000" ) == 0 ) {
		baudrate = CBR_256000;
	} else if( strcmp( argv[ 2 ], "-128000" ) == 0 ) {
		baudrate = CBR_128000;
	} else if( strcmp( argv[ 2 ], "-115200" ) == 0 ) {
		baudrate = CBR_115200;
	} else if( strcmp( argv[ 2 ], "-57600" ) == 0 ) {
		baudrate = CBR_57600;
	} else if( strcmp( argv[ 2 ], "-56000" ) == 0 ) {
		baudrate = CBR_56000;
	} else if( strcmp( argv[ 2 ], "-38400" ) == 0 ) {
		baudrate = CBR_38400;
	} else if( strcmp( argv[ 2 ], "-19200" ) == 0 ) {
		baudrate = CBR_19200;
	} else if( strcmp( argv[ 2 ], "-14400" ) == 0 ) {
		baudrate = CBR_14400;
	} else if( strcmp( argv[ 2 ], "-9600" ) == 0 ) {
		baudrate = CBR_9600;
	} else if( strcmp( argv[ 2 ], "-4800" ) == 0 ) {
		baudrate = CBR_4800;
	} else if( strcmp( argv[ 2 ], "-2400" ) == 0 ) {
		baudrate = CBR_2400;
	} else if( strcmp( argv[ 2 ], "-1200" ) == 0 ) {
		baudrate = CBR_1200;
	} else if( strcmp( argv[ 2 ], "-600" ) == 0 ) {
		baudrate = CBR_600;
	} else if( strcmp( argv[ 2 ], "-300" ) == 0 ) {
		baudrate = CBR_300;
	} else if( strcmp( argv[ 2 ], "-110" ) == 0 ) {
		baudrate = CBR_110;
	} else {
		printf(usageString);
		return -1;
	}

	inFile = fopen(argv[0], "rb");
	if (inFile == NULL)
	{
		printf("Error: File '%s' not found.\n", argv[0]);
		comPort->close();
		return -1;
	}

	// COM߰ĂJ
	if (!comPort->open(comPortName, baudrate, 2000))
	{
		printf("Error: %s in use or does not exist.\n", comPortName);
		return -1;
	}
	printf("%s opened.\n", comPortName);

	// ɏՕّ̧Ŝǂݍ
	while(fscanf(inFile, "%2X", &buffer[bufferSize]) == 1)
		bufferSize++;

	char * progressCharP = progressChars;	
	for(index = 0; index < bufferSize; index += frameSize)
	{
		frameSize = ((buffer[index] << 8) | buffer[index + 1]) + 2;

		// ǂȎM޲Ă
		comPort->setTimeOut(1);
		while (comPort->read(&receivedByte, 1));
		comPort->setTimeOut(4000);
		
		// ڰёo
		printf("\r                        \r"
		       "Transferring.. %c %d%% done.",
			*progressCharP++,
			100 * bytesSent / bufferSize);
		if( !(*progressCharP) ) progressCharP = progressChars;
		fflush( stdout );
		comPort->write(&buffer[index], frameSize);

		// 
		if (comPort->read(&receivedByte, 1))
		{
			switch (receivedByte)
			{
				case Error_OK:
					bytesSent += frameSize;
					retries = 0;
					break;

				default: // Error_CRC:
					if (++retries < 4)
						index -= frameSize;
					else 
					{
						printf("\nCRC error. File damaged.\n");
						comPort->close();
						fclose(inFile);
						return -1;
					}
					break;
			}
		}
		else
		{
			printf("\nFailed: Target is not responding.\n");

			comPort->close();
			fclose(inFile);

			return -1;
		}
	}

	// SI
	printf("\rTransferring.. 100%% done.  \n");
	fclose(inFile);
	comPort->close();

	printf("Target updated successfully.\n");
	return 0;
}
